float GGX (vec3 n, vec3 v, vec3 l, float r, float F0) {
    r*=r*r;
    
    vec3 h = normalize(l - v);

    float dotLH = clamp(dot(h,l),0.0,1.0);
    float dotNH = clamp(dot(h,n),0.0,1.0);
    float dotNL = clamp(dot(n,l),0.0,1.0);
    
    float denom = (dotNH * r - dotNH) * dotNH + 1.0;
    float D = r / (3.141592653589793 * denom * denom);
    float F = exp2((-5.55473*dotLH-6.98316)*dotLH) * (1.0-F0) + F0;
    float k2 = r * 0.25;

    float specular = max(dotNL * D * F / (dotLH*dotLH*(1.0-k2)+k2),0.0);
    specular = specular/(0.1*specular+1.0)*(1.0-r*(1.0-F0));

    return specular;
}